import ("voronoi");

private variable Triangle_Type = struct
{
   x, y, v0, v1, v2,
};

define triangulate (x, y)
{
   variable s = @Triangle_Type;
   s.x = x;
   s.y = y;
   (s.v0, s.v1, s.v2) = _voronoi_triangulate (x, y);
   return s;
}

define contiguous_voronoi_areas (t)
{
   variable v0 = t.v0, v1 = t.v1, v2 = t.v2;
   variable areas = _voronoi_triangle_area (t.x, t.y, v0, v1, v2);
   variable extended_areas = Double_Type[length(t.x)];

   _for (0, length (v1)-1, 1)
     {
	variable i = ();
	variable area = areas[i];
	extended_areas[v0[i]] += area;
	extended_areas[v1[i]] += area;
	extended_areas[v2[i]] += area;
     }
   return extended_areas;
}

